#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "constants.h"

extern void ConfigFPGA(HWND);
extern void ProgramFlash(HWND);
extern void	FailMessage(char *);

//---------------------------------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL CALLBACK MainDialogBox (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK StartDialogBox (HWND, UINT, WPARAM, LPARAM);

HDC				hdcMainWin;
HWND			hwndMainWin;
MSG				msg;
WNDCLASSEX		wndclass;
DCB 			dcb;
COMMTIMEOUTS	cmto;
HANDLE 			hCom = NULL, hFile;
HINSTANCE		hInstance;
OPENFILENAME	ofn;

int		i, j, file_length, start_address;
char	*pFileBuffer = NULL, *pFlashBuffer = NULL, szStartAddr[13];
char 	WorkDirectory[256], szFileName[256], com_port_name[5];

char	szFilter1[] = "raw binary files (*.rbf)\0*.rbf\0" \
					  "hex files (*.hex)\0*.hex\0" \
					  "all files (*.*)\0*.*\0";

char	szFilter2[] = "raw binary files (*.rbf)\0*.rbf\0";

char	szAppName[] = "Flash Programmer v1.0";

//---------------------------------------------------------------------------------------
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
					PSTR szCmdLine, int iCmdShow)
{
	wndclass.cbSize        = sizeof (wndclass) ;
	wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
	wndclass.lpfnWndProc   = WndProc ;
	wndclass.cbClsExtra    = 0 ;
	wndclass.cbWndExtra    = 0 ;
	wndclass.hInstance     = hInstance ;
	wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
	wndclass.hbrBackground = (HBRUSH) GetStockObject (LTGRAY_BRUSH) ;
	wndclass.lpszMenuName  = NULL ;
	wndclass.lpszClassName = szAppName ;
	wndclass.hIconSm       = LoadIcon (NULL, IDI_APPLICATION) ;

	RegisterClassEx (&wndclass) ;

    ofn.lStructSize			= sizeof (OPENFILENAME);
    ofn.hwndOwner			= NULL;
    ofn.hInstance			= NULL;
	ofn.lpstrFilter			= szFilter1;
    ofn.lpstrCustomFilter	= NULL;
    ofn.nMaxCustFilter		= 0;
    ofn.nFilterIndex		= 0;
    ofn.lpstrFile			= szFileName;
    ofn.nMaxFile			= _MAX_PATH;
    ofn.lpstrFileTitle		= NULL;
    ofn.nMaxFileTitle		= _MAX_FNAME + _MAX_EXT;
    ofn.lpstrInitialDir		= WorkDirectory;
    ofn.lpstrTitle			= NULL;
	ofn.Flags				= OFN_HIDEREADONLY | OFN_CREATEPROMPT;
    ofn.nFileOffset			= 0;
    ofn.nFileExtension		= 0;
    ofn.lpstrDefExt			= NULL;
    ofn.lCustData			= 0L;
    ofn.lpfnHook			= NULL;
    ofn.lpTemplateName		= NULL;

	hwndMainWin = CreateWindow (szAppName,	// window class name
					"Flash Programmer v1.0",    // window caption
                    NULL,					// window style
                    2000,          			// initial x position
                    2000,          			// initial y position
                    0,				        // initial x size
                    0,          			// initial y size
                    NULL,                   // parent window handle
                    NULL,                   // window menu handle
                    hInstance,              // program instance handle
		            NULL) ;		            // creation parameters

	ShowWindow (hwndMainWin, iCmdShow) ;
	UpdateWindow (hwndMainWin) ;
	hdcMainWin = GetDC(hwndMainWin);

    SetBkColor (hdcMainWin, GetSysColor(COLOR_BTNFACE));

	while (GetMessage(&msg, NULL, 0, 0) == TRUE)
    {
		TranslateMessage (&msg) ;
		DispatchMessage (&msg) ;
    }

 	ReleaseDC(hwndMainWin, hdcMainWin);
    return msg.wParam ;
}

//---------------------------------------------------------------------------------------
// Windows Programm
//---------------------------------------------------------------------------------------

LRESULT CALLBACK WndProc (HWND hwndMainWin, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
    	case WM_CREATE :					// Fenster geffnet
			hInstance = ((LPCREATESTRUCT) lParam)->hInstance ;
        return(0);
	
		case WM_SIZE:
			DialogBox (hInstance, "MAIN", hwndMainWin, (DLGPROC)MainDialogBox);
		return(0);

        case WM_COMMAND :
        return(0);

		case WM_DESTROY :                   // Fenster wird geschlossen
			if(hCom)
            {
            	CloseHandle (hCom);
            }
			if(pFlashBuffer != NULL)
			{
				free(pFlashBuffer);
			}
			if(pFileBuffer != NULL)
			{
				free(pFileBuffer);
			}
			PostQuitMessage (0) ;
		return(0);
    }
	return DefWindowProc (hwndMainWin, iMsg, wParam, lParam) ;
}

//---------------------------------------------------------------------------------------
// Das eigentliche Hauptprogramm, welches die Eingaben aus dem Hauptfenster verarbeitet
//---------------------------------------------------------------------------------------

BOOL CALLBACK MainDialogBox (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
		case WM_INITDIALOG:
			pFlashBuffer = (char *)malloc(FLASH_SIZE);	// Speicher in der Gre des Flashspeichers reservieren
			memset (pFlashBuffer, 0xFF, FLASH_SIZE);	// und mit Einsen fllen
		return(true);

		case WM_COMMAND :
		switch (LOWORD (wParam))
		{
			case GID_FPGA_CFG:
				ConfigFPGA(hDlg);				// FPGA konfigurieren
			break;
			
			case GID_USB_DEV:					// Ausgewhlten COM-Port feststellen
			break;


			case GID_PROG_FLASH:				// Flashspeicher programmieren und vergleichen
				ProgramFlash(hDlg);
			break;

			case GID_COPYRIGHT:
				FailMessage("Valerij Matrose\nwww.fpga-dev.de\nApril 2007");
			break;

			case IDCANCEL:						// Programm beenden
				PostQuitMessage (0) ;
				EndDialog (hDlg, 0);
			return(true);
		}
	}
	return(false);
}

//---------------------------------------------------------------------------------------
// Dialog zur Eingabe der Startadresse
//---------------------------------------------------------------------------------------
BOOL CALLBACK StartDialogBox (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	int i;
	switch (iMsg)
	{
		case WM_INITDIALOG:
			SetDlgItemText(hDlg, GID_START_ADDR, "0x00080000");
		return(true);

		case WM_COMMAND :
		switch (LOWORD (wParam))
		{
			case IDOK:
				GetDlgItemText(hDlg, GID_START_ADDR, szStartAddr, 11);
				szStartAddr[10] = 0;
				if(szStartAddr[0] == '0' && szStartAddr[1] == 'x')
				{
					for(i=2; i<10; i++)
					{
						if((szStartAddr[i] >= '0' && szStartAddr[i] <= '9') || (szStartAddr[i] >= 'a' && szStartAddr[i] <= 'f') || (szStartAddr[i] >= 'A' && szStartAddr[i] <= 'F'))
						{}
						else
						{
							if(szStartAddr[i] == 0) break;
							FailMessage("Only chars [0..9], [a..f], [A..F] are allowed!");
							return(true);
						}
					}
					sscanf(szStartAddr, "%x", &start_address);
					EndDialog (hDlg, 1);		// Dialogfenster schlieen
					return(true);					
				}
				else
				{
					FailMessage("A hexadecimal number starts with '0x'!");
					return(true);
				}

			case IDCANCEL:						// Dialogfenster schlieen
				EndDialog (hDlg, 0);
			return(true);
		}
	}
	return(false);
}